#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include "selinux_internal.h"

int hidden setprocattrcon_raw(char *context, const char *proc_entry)
{
	int fd;
	ssize_t ret;
	int errno_hold;

	fd = open(proc_entry, O_RDWR);
	if (fd < 0)
		return -1;
	if (context)
		do {
			ret = write(fd, context, strlen(context) + 1);
		} while (ret < 0 && errno == EINTR);
	else
		do {
			ret = write(fd, NULL, 0);	/* clear */
		} while (ret < 0 && errno == EINTR);
	errno_hold = errno;
	close(fd);
	errno = errno_hold;
	if (ret < 0)
		return -1;
	else
		return 0;
}

int hidden setprocattrcon(char *context, const char *proc_entry)
{
	int ret;
	security_context_t rcontext = context;

	if (selinux_trans_to_raw_context(context, &rcontext))
		return -1;

	ret = setprocattrcon_raw(rcontext, proc_entry);

	freecon(rcontext);

	return ret;
}
